"use strict";
$(function() {
  function createColorpickers() {
    
    var bodyStyle = $('body')[0].style;
    $('#demo_apidemo').colorpicker({
      color: bodyStyle.backgroundColor
    }).on('changeColor', function(ev) {
      bodyStyle.backgroundColor = ev.color.toHex();
    });

    $('#demo_forceformat').colorpicker({
      format: 'rgba',
      horizontal: true
    });

    $('.demo-auto').colorpicker();

    $('#demo_selectors').colorpicker({
      colorSelectors: {
        'default': '#777777',
        'primary': '#337ab7',
        'success': '#5cb85c',
        'info': '#5bc0de',
        'warning': '#f0ad4e',
        'danger': '#d9534f'
      }
    });

    $('.demo-with-options').colorpicker({
      color: '#ff0000',
      format: 'hex'
    });

    $('#demo_size').colorpicker({
      customClass: 'colorpicker-2x',
      sliders: {
        saturation: {
          maxLeft: 200,
          maxTop: 200
        },
        hue: {
          maxTop: 200
        },
        alpha: {
          maxTop: 200
        }
      }
    });

    $(".disable-button").click(function(e) {
      e.preventDefault();
      $("#demo_endis").colorpicker('disable');
    });

    $(".enable-button").click(function(e) {
      e.preventDefault();
      $("#demo_endis").colorpicker('enable');
    });
  }

  createColorpickers();


  $('.demo-destroy').click(function(e) {
    e.preventDefault();
    $('.demo').colorpicker('destroy');
    $(".disable-button, .enable-button").off('click');
  });

  $('.demo-create').click(function(e) {
    e.preventDefault();
    createColorpickers();
  });
});
