<?php
    session_start();
    http_response_code(200);
    date_default_timezone_set('Portugal');
    include('config.php'); 
    include("backoffice/php/swift_required.php");

    $data = file_get_contents("php://input");
    $event = json_decode($data, true);
    $headers = apache_request_headers();
    foreach ($headers as $header => $value) {
        if ($header=="X-Authentication-Tag") {
            $x_autenthication_tag = $value;
        } else if ($header=="X-Initialization-Vector") {
            $x_initialization_vector = $value;
        }
    }
    $key_from_configuration = "1A406122888B28E9F064BDCDE1661C26C3CFFC4CD1AEF363B72F84D2381164FD";
    $iv_from_http_header = $x_initialization_vector;
    $auth_tag_from_http_header = $x_autenthication_tag;
    $http_body = $event['encryptedBody'];    
    $key = hex2bin($key_from_configuration);
    $iv = hex2bin($iv_from_http_header);
    $auth_tag = hex2bin($auth_tag_from_http_header);
    $cipher_text = hex2bin($http_body);    
    $result = openssl_decrypt($cipher_text, "aes-256-gcm", $key, OPENSSL_RAW_DATA, $iv, $auth_tag);
    $data = json_decode($result);
    $paymentBrand = $data->payload->paymentBrand;
    $paymentType = $data->payload->paymentType;

    if ($paymentBrand=="SIBS_MULTIBANCO") {
        if ($paymentType=="RC") {
            $merchantTransactionId = $data->payload->merchantTransactionId;
            if ($merchantTransactionId!="") {
                $result_multibanco = $pdo->prepare("SELECT * FROM multibanco WHERE estado = 0 AND merchantTransactionId = :merchantTransactionId");
                $result_multibanco->execute(array('merchantTransactionId' => $merchantTransactionId));
                $num_rows_multibanco = $result_multibanco->rowCount();
                $row_multibanco = $result_multibanco->fetch();
                if ($num_rows_multibanco==1) {
                    $query = $pdo->prepare("UPDATE multibanco SET estado = 1 WHERE merchantTransactionId = :merchantTransactionId");
                    $query->execute(array('merchantTransactionId' => $merchantTransactionId));
                    $query_encomenda = $pdo->prepare("UPDATE encomendas SET estado = 0 WHERE id_encomendas = :encomenda");
                    $query_encomenda->execute(array('encomenda' => $row_multibanco['encomenda']));
                    $result_encomenda = $pdo->prepare("SELECT * FROM encomendas WHERE id_encomendas = :encomenda");
                    $result_encomenda->execute(array('encomenda' => $row_multibanco['encomenda']));
                    $row_encomenda = $result_encomenda->fetch();
					
                    $email = "encomendas@threelandbrand.com";
                    $titulo = "Pagamento Efetuado";
                    $subject = "Pagamento Efetuado";                        
                    $texto1 = "Foi efetuado o pagamento da encomenda ".$row_encomenda['codigo']." através do multibanco.";
                    $l = "?l=pt";
                    $simbolo = "?";
                    $filename = "pt.json";     
                    $string = file_get_contents($filename);
                    $textos = json_decode($string,true);          
                    $transport = Swift_SmtpTransport::newInstance('mail.abedigitalsolutions.com', 25);
                    $transport->setUsername('send@abemkt.com');
                    $transport->setPassword(';cXfx;G(iM]YUqZ#-F');  
                    $mailer = Swift_Mailer::newInstance($transport);
                    $message = Swift_Message::newInstance();
                    $mailer->registerPlugin(new Swift_Plugins_AntiFloodPlugin(20, 60));
                    $body = '<html>
								<head>
									<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
									<title></title>
									<meta name="viewport" content="width=device-width, initial-scale=1">
								</head>
								<style>
									.ExternalClass * {line-height: 100%;} 
									.ExternalClass p, .ExternalClass span, .ExternalClass font, .ExternalClass td, .ExternalClass div {line-height: 100%;} 
									a {line-height: 14px;}  
									body {background-color: #ddd;}
								</style>
								<body>
									<table style="font-family: Verdana, Geneva, sans-serif; font-size: 11px; color: #333" width="100%" align="center" bgcolor="#fff" border="0" cellpadding="0" cellspacing="0">
										<thead>
											<tr>
												<td style="color: #ffffff; background-color: #ccc;" align="center" bgcolor="#aaa">
													<table width="530" border="0" cellpadding="0" cellspacing="0">
														<tbody>
															<tr>
																<td style="font-family: Verdana, Geneva, sans-serif; font-size: 10px; color: #ffffff;" valign="middle" width="530" align="left" height="24"><a href="https://www.threelandbrand.com/index.php'.$l.'" style="color: #ffffff;" target="_blank"><span style="color: #ffffff;">https://www.threelandbrand.com</span></a></td>
															</tr>
														</tbody>
													</table>
												</td>
											</tr>
										</thead>
										<tbody width="530">
											<tr width="530">
												<td align="center" valign="top" bgcolor="#ddd" width="530">
													<table cellpadding="0" cellspacing="0" border="0" width="530" bgcolor="#ddd">
														<tbody>
															<tr>
																<td width="530" align="left" valign="top">
																	<table cellpadding="0" cellspacing="0" border="0" width="530">
																		<tbody>
																			<tr>
																				<td>
																					<a href="https://www.threelandbrand.com/index.php'.$l.'" style="color: #ffffff;" target="_blank">
																						<img src="https://www.threelandbrand.com/backoffice/imagens/newsletter/barra_topo.jpg" alt="threelandbrand" width="530" height="87" border="0" style="display: block;">
																					</a>
																				</td>
																			</tr>
																			<tr>                                    
																				<td align="center" width="530" style="background-color: #aaa; width: 530px;">
																					<table cellpadding="0" cellspacing="0" border="0" width="530" style="width: 530px;">
																						<tbody>
																							<tr>
																								<td height="20" width="176" align="center" valign="middle" bgcolor="#aaa" style="color: #ffffff; font-family: Verdana, Geneva, sans-serif; font-size: 12px;">
																									<a href="https://www.threelandbrand.com/produtos.php'.$l.'" style="text-decoration: none;" target="_blank">
																										<span style="color: #ffffff;">threelandbrand</span>
																									</a>
																								</td>
																							</tr>
																						</tbody>
																					</table>
																				</td>
																			</tr>
																			<tr>
																				<td style="font-family: Verdana, Geneva, sans-serif; text-align: center; font-size: 11px; color: #333; background-color: #fff;" width="100%" align="center" bgcolor="#fff" height="20">
																					<br>
																					'.$titulo.'
																					<br><br>
																				</td>
																			</tr>
																			<tr>
																				<td valign="top" bgcolor="#FFFFFF" height="10" width="530" style="border-bottom: 1px dotted #cccccc; display: block;"></td>
																			</tr>
																			<tr>
																				<td valign="top" bgcolor="#FFFFFF" height="10" width="530"></td>
																			</tr>
																			<tr>
																				<td width="530">
																					<table cellpadding="0" cellspacing="0" border="0" width="530">
																						<tbody>
																							<tr width="530">
																								<td width="20" bgcolor="#FFFFFF"></td>
																								<td width="488" bgcolor="#FFFFFF" style="font-family: Verdana, Geneva, sans-serif; font-size: 12px; line-height: 16px; color: #333333;">'.$texto1.'<br><br>';
																								$body.='</td>
																								<td width="20" bgcolor="#FFFFFF"></td>
																							</tr>
																						</tbody>
																					</table>
																				</td>
																			</tr>
																			<tr>
																				<!--<td align="left" valign="top" bgcolor="#ADADAD">
																					<table cellpadding="0" cellspacing="0" border="0">
																						<tbody>
																							<tr>
																								<td width="10"></td>
																								<td width="510" align="left" style="font-family: Verdana, Geneva, sans-serif; color: #ffffff; font-size: 11px; line-height: 15px">
																									'.$textos['email_rodape1'].' <a href="mailto:info@threelandbrand.com" style="color: #ffffff;" target="_blank"><span style="color: #ffffff;">info@threelandbrand.com</span></a> '.$textos['email_rodape2'].'
																									<br>
																									<br>
																									©2020 <a href="https://www.threelandbrand.com/index.php'.$l.'" style="color: #ffffff;" target="_blank"><span style="color: #ffffff;">threelandbrand</span></a><br>
																									Rua de St. António nº 125 3º Esq., 3730 - 249 Vale de Cambra | '.$textos['telefone'].': 915 565 069
																								</td>                                        
																							</tr>
																							<tr>
																								<td height="10"></td>
																							</tr>
																						</tbody>
																					</table>
																				</td>-->
																			</tr>
																		</tbody>
																	</table>
																</td>
															</tr>
														</tbody>
													</table>
												</td>
											</tr>
										</tbody>
									</table>
								</body>
							</html>';
                            
					$message->setBody($body,'text/html');
					$message->setSubject($subject);
					$message->setFrom(array('no-reply@threelandbrand.com' => 'threelandbrand'));                                                   
					$message->setTo(array($email));
					$mailer->send($message, $failures);
					
					$result_cliente = $pdo->prepare("SELECT * FROM clientes WHERE id_clientes = :id");
					$result_cliente->execute(array('id' => $row_encomenda['id_clientes']));
					$row_cliente = $result_cliente->fetch();
					$email = $row_cliente['email_clientes'];
					$l = "?l=".$row_cliente['lingua'];
					$simbolo = "?";
					$filename = $row_cliente['lingua'].".json";
					$string = file_get_contents($filename);
					$textos = json_decode($string,true);
					$titulo = $textos['pagamento_efetuado'];
					$subject = $textos['pagamento_efetuado'];
					$texto1 = $textos['texto_pagamento_1'].$row_encomenda['codigo'].$textos['texto_pagamento_2'];                        
					$transport = Swift_SmtpTransport::newInstance('mail.abedigitalsolutions.com', 25);
					$transport->setUsername('send@abemkt.com');
					$transport->setPassword(';cXfx;G(iM]YUqZ#-F');  
					$mailer = Swift_Mailer::newInstance($transport);
					$message = Swift_Message::newInstance();
					$mailer->registerPlugin(new Swift_Plugins_AntiFloodPlugin(20, 60));
					$body = '<html>
								<head>
									<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
									<title></title>
									<meta name="viewport" content="width=device-width, initial-scale=1">
								</head>
								<style>
									.ExternalClass * {line-height: 100%;} 
									.ExternalClass p, .ExternalClass span, .ExternalClass font, .ExternalClass td, .ExternalClass div {line-height: 100%;} 
									a {line-height: 14px;}  
									body {background-color: #ddd;}
								</style>
								<body>
									<table style="font-family:Verdana,Geneva,sans-serif;font-size:11px;color:#333" width="100%" align="center" bgcolor="#fff" border="0" cellpadding="0" cellspacing="0">
										<thead>
											<tr>
												<td style="color:#ffffff; background-color: #ccc;" align="center" bgcolor="#aaa">
													<table width="530" border="0" cellpadding="0" cellspacing="0">
														<tbody>
															<tr>
																<td style="font-family: Verdana, Geneva, sans-serif; font-size: 10px; color: #ffffff;" valign="middle" width="530" align="left" height="24"><a href="https://www.threelandbrand.com/index.php'.$l.'" style="color: #ffffff;" target="_blank"><span style="color: #ffffff;">https://www.threelandbrand.com</span></a></td>
															</tr>
														</tbody>
													</table>
												</td>
											</tr>
										</thead>
										<tbody width="530">
											<tr width="530">
												<td align="center" valign="top" bgcolor="#ddd" width="530">
													<table cellpadding="0" cellspacing="0" border="0" width="530" bgcolor="#ddd">
														<tbody>
															<tr>
																<td width="530" align="left" valign="top">
																	<table cellpadding="0" cellspacing="0" border="0" width="530">
																		<tbody>
																			<tr>
																				<td>
																					<a href="https://www.threelandbrand.com/index.php'.$l.'" style="color: #ffffff;" target="_blank">
																						<img src="https://threelandbrand.com/backoffice/imagens/newsletter/barra_topo.jpg" alt="threelandbrand" width="530" height="87" border="0" style="display: block;">
																					</a>
																				</td>
																			</tr>
																			<tr>                                    
																				<td align="center" width="530" style="background-color: #aaa; width: 530px;">
																					<table cellpadding="0" cellspacing="0" border="0" width="530" style="width: 530px;">
																						<tbody>
																							<tr>
																								<td height="20" width="176" align="center" valign="middle" bgcolor="#aaa" style="color: #ffffff; font-family: Verdana, Geneva, sans-serif; font-size: 12px;">
																									<a href="https://www.threelandbrand.com/produtos.php'.$l.'" style="text-decoration: none;" target="_blank">
																										<span style="color: #ffffff;">threelandbrand</span>
																									</a>
																								</td>
																							</tr>
																						</tbody>
																					</table>
																				</td>
																			</tr>
																			<tr>
																				<td style="font-family: Verdana, Geneva, sans-serif; text-align: center; font-size: 11px; color: #333; background-color: #fff;" width="100%" align="center" bgcolor="#fff" height="20">
																					<br>
																					'.$titulo.'
																					<br><br>
																				</td>
																			</tr>
																			<tr>
																				<td valign="top" bgcolor="#FFFFFF" height="10" width="530" style="border-bottom: 1px dotted #cccccc; display: block;"></td>
																			</tr>
																			<tr>
																				<td valign="top" bgcolor="#FFFFFF" height="10" width="530"></td>
																			</tr>
																			<tr>
																				<td width="530">
																					<table cellpadding="0" cellspacing="0" border="0" width="530">
																						<tbody>
																							<tr width="530">
																								<td width="20" bgcolor="#FFFFFF"></td>
																								<td width="488" bgcolor="#FFFFFF" style="font-family: Verdana, Geneva, sans-serif; font-size: 12px; line-height: 16px; color: #333333">'.$texto1.'<br><br></td>
																								<td width="20" bgcolor="#FFFFFF"></td>
																							</tr>
																						</tbody>
																					</table>
																				</td>
																			</tr>
																			<tr>
																				<td align="left" valign="top" bgcolor="#ADADAD">
																					<table cellpadding="0" cellspacing="0" border="0">
																						<tbody>
																							<tr>
																								<td width="10"></td>
																								<td width="510" align="left" style="font-family: Verdana, Geneva, sans-serif; color: #ffffff; font-size: 11px; line-height: 15px;">
																									'.$textos['email_rodape1'].' <a href="mailto:info@threelandbrand.com" style="color: #ffffff;" target="_blank"><span style="color: #ffffff;">info@threelandbrand.com</span></a>'.$textos['email_rodape2'].'<br><br>©2020 <a href="https://www.threelandbrand.com/index.php'.$l.'" style="color: #ffffff;" target="_blank"><span style="color:#ffffff">threelandbrand</span></a><br>Rua de St. António nº 125 3º Esq., 3730 - 249 Vale de Cambra | '.$textos['telefone'].': 915 565 069
																								</td>                                        
																							</tr>
																							<tr>
																								<td height="10"></td>
																							</tr>
																						</tbody>
																					</table>
																				</td>
																			</tr>
																		</tbody>
																	</table>
																</td>
															</tr>
														</tbody>
													</table>
												</td>
											</tr>
										</tbody>
									</table>
								</body>
							</html>';

					$message->setBody($body,'text/html');
					$message->setSubject($subject);
					$message->setFrom(array('no-reply@threelandbrand.com' => 'threelandbrand'));
					$message->setTo(array($email));
					$mailer->send($message, $failures); 
                }                                    
            } 
        }
    }
?>