<?php
    session_start();
    include('linguas.php');
	include('config.php');
    include('php/colors.php');
?>
<div class="row">
    <div class="col-lg-12">
        <div class="cart-table table-responsive">
            <table class="table table-bordered">
                <thead>
                    <tr>
                        <th class="pro-thumbnail"><?php echo $textos['miniatura'];?></th>
                        <th class="pro-title"><?php echo $textos['produto'];?></th>
                        <th class="pro-title"><?php echo $textos['tamanho'];?></th>
						<th class="pro-title"><?php echo $textos['quantidade'];?></th>
                        <th class="pro-price"><?php echo $textos['preco'];?></th>
                    </tr>
                </thead>
                <tbody> 
<?php
    

    function html2rgb($color){
        if ($color[0]=='#')
            $color = substr($color, 1);
        if (strlen($color)==6)
            list($r, $g, $b) = array($color[0].$color[1], $color[2].$color[3], $color[4].$color[5]);
		else if (strlen($color)==3)
			list($r, $g, $b) = array($color[0].$color[0], $color[1].$color[1], $color[2].$color[2]);
		else
			return false;
		$r = hexdec($r);
		$g = hexdec($g);
		$b = hexdec($b);   
        return array($r, $g, $b);
    }
                                
    function distancel2(array $color1, array $color2) {
        return sqrt(pow($color1[0]-$color2[0], 2)+pow($color1[1]-$color2[1], 2)+pow($color1[2]-$color2[2], 2));
    }
                        
    if (isset($_SESSION['id_clientes']) && $_SESSION['id_clientes']!='' && isset($_SESSION['id_carrinho']) && $_SESSION['id_carrinho']!='') {
        $result = $pdo->prepare("SELECT * FROM carrinho_produtos WHERE id_carrinho = :id_carrinho ORDER BY id_produtos DESC, id_carrinho_produtos DESC");
        $result->execute(array('id_carrinho' => $_SESSION['id_carrinho']));
        $num_rows = $result->rowCount();
        $row = $result->fetch();
        $total = 0;
        if ($num_rows>0) {
            for ($i=1;$i<=$num_rows;$i++) {
                $stmt_p = $pdo->prepare('SELECT * FROM `produtos_sku` INNER JOIN produtos ON produtos_sku.id_produto = produtos.id_produtos WHERE produtos_sku.sku = :sku');
                $stmt_p->execute(array('sku' => $row['sku']));
                $num_rows_p = $stmt_p->rowCount();
                $row_p = $stmt_p->fetch();  
				
                $stmt_c = $pdo->prepare('SELECT * FROM cores WHERE sku = :sku');
                $stmt_c->execute(array('sku' => $row['sku']));
                $num_rows_c = $stmt_c->rowCount();
                $row_c = $stmt_c->fetch();        
                if (is_null($row_c['n_aplicavel']) && !is_null($row_c['cor'])) {
                    $distances = array();
                    $val = html2rgb($row_c['cor']);
                    foreach ($colors as $name => $c) {
                        $distances[$name] = distancel2($c, $val);
                    }                                                    
                    $mincolor = "";
                    $minval = pow(2, 553);
                    foreach ($distances as $k => $v) {
                        if ($v < $minval) {
                            $minval = $v;
                            $mincolor = $k;
                        }
                    }                           
                    $cor_n = substr($mincolor, 0, strpos($mincolor, '_'));  
                    if ($cor_n=="Vermelho") {
                        $cor = $textos['vermelho'];
                    } else if ($cor_n=="Amarelo") {
                        $cor = $textos['amarelo'];
                    } else if ($cor_n=="Verde") {
                        $cor = $textos['verde'];
                    } else if ($cor_n=="Azul") {
                        $cor = $textos['azul'];
                    } else if ($cor_n=="Bege") {
                        $cor = $textos['bege'];
                    } else if ($cor_n=="Rosa") {
                        $cor = $textos['rosa'];
                    } else if ($cor_n=="Lilas") {
                        $cor = $textos['lilas'];
                    } else if ($cor_n=="Laranja") {
                        $cor = $textos['laranja'];
                    } else if ($cor_n=="Castanho") {
                        $cor = $textos['castanho'];
                    } else if($cor_n=="Bordeaux") {
                        $cor = $textos['bordeaux'];
                    } else if ($cor_n=="Roxo") {
                        $cor = $textos['roxo'];
                    } else if ($cor_n=="Cinza") {
                        $cor = $textos['cinza'];
                    } else if ($cor_n=="Preto") {
                        $cor = $textos['preto'];
                    } else if ($cor_n=="Branco") {
                        $cor = $textos['branco'];
                    }                            
                } else {
                    $cor = $textos['n_aplicavel'];
                }                                                   
                                
                $result_t = $pdo->prepare('SELECT * FROM tamanhos WHERE sku = :sku');
                $result_t->execute(array('sku' => $row['sku']));
                $num_rows_t = $result_t->rowCount();
                $row_t = $result_t->fetch();
                if (is_null($row_t['unico']) && is_null($row_t['n_aplicavel']) && !is_null($row_t['tamanho'])) {
                    $tamanho = $row_t['tamanho'];
                } else if($row_t['unico']=='1') {
                    $tamanho = $textos['unico'];
                } else {
                    $tamanho = "<span title=\"".$textos['n_aplicavel']."\">".$textos['n_aplicavel']."</span>";
                }
                        
				$stmt_i = $pdo->prepare('SELECT * FROM `produtos_sku` INNER JOIN produtos ON produtos_sku.id_produto = produtos.id_produtos WHERE produtos_sku.sku = :sku');
                $stmt_i->execute(array('sku' => $row['sku']));
                $num_rows_i = $stmt_i->rowCount();
                $row_i = $stmt_i->fetch();

                date_default_timezone_set('Portugal');
                $hoje = date('Y-m-d');                    
				// CAMPANHA DE DESCONTO IGUAL EM TODOS OS PRODUTOS   
				$result_campanha = $pdo->prepare("SELECT * FROM campanhas WHERE data_inicio <= :hoje AND data_fim >= :hoje2 ORDER BY id_campanha DESC LIMIT 1");
				$result_campanha->execute(array('hoje' => $hoje, 'hoje2' => $hoje));
				$row_campanha = $result_campanha->fetch();
				$num_campanha = $result_campanha->rowCount();
				if ($num_campanha>0) {
					$taxa = "0.".(100-$row_campanha['desconto']);
					$preco2 = number_format((float)$row_p['preco_produtos']*$taxa, 2, '.', '');
				}											
				
				//DESCONTO por ID PRODUTO
				$result_desconto = $pdo->prepare("SELECT * FROM promocoes WHERE id_produtos = :id AND data_inicio <= :hoje AND data_fim >= :hoje2 AND sku IS NULL");
				$result_desconto->execute(array('id' => $row_i['id_produtos'], 'hoje' => $hoje, 'hoje2' => $hoje));
				$row_desconto = $result_desconto->fetch();
				$num_desconto = $result_desconto->rowCount();
				
				if ($num_desconto>0) {
					$taxa = "0.".(100-$row_desconto['promocao']);
					$preco2 = number_format((float)$row_p['preco_produtos']*$taxa, 2, '.', '');
				}
				
				//DESCONTO UNITÀRIO POR SKU DO MODELO DE PRODUTO												
				$result_desconto = $pdo->prepare("SELECT * FROM promocoes WHERE sku = :sku AND data_inicio <= :hoje AND data_fim >= :hoje2");
				$result_desconto->execute(array('sku' => $row_i['sku'], 'hoje' => $hoje, 'hoje2' => $hoje));
				$row_desconto = $result_desconto->fetch();
				$num_desconto2 = $result_desconto->rowCount();
				if ($num_desconto2>0) {
					$taxa = "0.".(100-$row_desconto['promocao']);
					$preco2 = number_format((float)$row_p['preco_produtos']*$taxa, 2, '.', '');													
				}	
				
				if ($num_campanha>0 || $num_desconto>0 || $num_desconto2>0) {
					$pre_quantidade = $preco2*$row['quantidade'];
				} else {
					$pre_quantidade = $row_p['preco_produtos']*$row['quantidade'];
				}
				$preco_old = $row_p['preco_produtos']*$row['quantidade'];
                $quantidade = $row['quantidade'];     
                $total = $total+$pre_quantidade;
                                        
                if (file_exists("backoffice/imagens/produtos/produtos/".$row_i['id_produtos']."/".$row_i['imagens']."/1_img.jpg")) {
					$imagemgaleria = "backoffice/imagens/produtos/produtos/".$row_i['id_produtos']."/".$row_i['imagens']."/1_img.jpg";
				} else if (file_exists("backoffice/imagens/produtos/produtos/".$row_i['id_produtos']."/".$row_i['imagens']."/1_img.JPG")) {
					$imagemgaleria = "backoffice/imagens/produtos/produtos/".$row_i['id_produtos']."/".$row_i['imagens']."/1_img.JPG";
				} else {
					$imagemgaleria = "backoffice/imagens/imgs/img_esq.jpg";
				}                        

                if ($lingua=="en") {
                    $nome_mostrar = $row_p['nome_produtos_en'];
                } else {
                    $nome_mostrar = $row_p['nome_produtos'];
                }

                echo '<tr>
                        <td class="pro-thumbnail"><a href="produto.php?id='.$row_p['id_produtos'].'&l='.$lingua.'"><img class="img-fluid" src="'.$imagemgaleria.'" alt="'.$nome_mostrar.'" /></a></td>
                        <td class="pro-title"><a href="produto.php?id='.$row_p['id_produtos'].'&l='.$lingua.'">'.$nome_mostrar.'</a></td>
                        <td class="pro-title">'.$tamanho.'</td>
						<td class="pro-title">'.$quantidade.'</td>';
				if ($num_campanha>0 || $num_desconto>0 || $num_desconto2>0) {
					echo '<td class="pro-price"><span class="price-old" style="font-size: 14px"><del>'.number_format((float)$preco_old, 2, '.', '').'€</del></span> <span>'.number_format((float)$pre_quantidade, 2, '.', '').'€</span></td>';
				}else{
					echo '<td class="pro-price"><span>'.number_format((float)$pre_quantidade, 2, '.', '').'€</span></td>';
				}
				echo '</tr>';
                $row = $result->fetch();
            } 
        } else {
            echo "<tr><td colspan='7'>".$textos['carrinho_vazio']."</td></tr>";
        }
    } else {
        echo "<tr><td colspan='7'>".$textos['carrinho_vazio']."</td></tr>";
    }
?>
                </tbody>
            </table>
        </div>
    </div>
</div>
<?php if ($num_rows>0) {?>
    <div class="row">
        <div class="col-lg-7 ml-auto">
            <div class="cart-update-option d-block d-md-flex justify-content-between">
                <div class="apply-coupon-wrapper">
                    <form class=" d-block d-md-flex">
                        <?php
                            $resultc = $pdo->prepare("SELECT * FROM carrinho WHERE id_carrinho = :carrinho");
                            $resultc->execute(array('carrinho' => $_SESSION['id_carrinho']));
                            $rowc = $resultc->fetch();
                            if (!is_null($rowc['voucher'])) {
                                date_default_timezone_set('Portugal');
                                $hoje = date('Y-m-d');
                                $result_voucher = $pdo->prepare("SELECT * FROM vouchers WHERE (data_inicio <= :hoje AND data_fim >= :hoje2) AND ((infinito = 1) OR (infinito = 0 AND utilizacao > 0)) AND id_voucher = :voucher ORDER BY id_voucher DESC");
                                $result_voucher->execute(array('hoje' => $hoje, 'hoje2' => $hoje, 'voucher' => $rowc['voucher']));
                                $row_voucher = $result_voucher->fetch();
                                $codigo_voucher = $row_voucher['voucher'];
                            } else {
                                $codigo_voucher = "";
                            }
                        ?>
                        <input type="text" name="voucher" id="voucher" placeholder="<?php echo $textos['introduza_voucher'];?>" value="<?php echo $codigo_voucher;?>"/>
                        <button class="btn" id="btn_voucher" onclick="checkVoucher()"><?php echo $textos['aplicar_voucher'];?></button>
                    </form>
                </div>
            </div>
        </div>
        <div class="col-lg-5 ml-auto">
            <div class="cart-calculator-wrapper" style="min-height: 250px; !important">
                <div class="cart-calculate-items">
                    <h3><?php echo $textos['totais'];?></h3>
                    <div class="table-responsive">
                        <table class="table">
                            <tr>
                                <td><?php echo $textos['subtotal'];?></td>
                                <td><?php echo number_format((float)$total, 2, '.', '');?>€</td>
                            </tr>
                           
                            <?php
                                $resultc = $pdo->prepare("SELECT * FROM carrinho WHERE id_carrinho = :carrinho");
                                $resultc->execute(array('carrinho' => $_SESSION['id_carrinho']));
                                $rowc = $resultc->fetch();
                                if (!is_null($rowc['voucher'])) {
                                    date_default_timezone_set('Portugal');
                                    $hoje = date('Y-m-d');
                                    $result_voucher = $pdo->prepare("SELECT * FROM vouchers WHERE (data_inicio <= :hoje AND data_fim >= :hoje2) AND ((infinito = 1) OR (infinito = 0 AND utilizacao > 0)) AND id_voucher = :voucher ORDER BY id_voucher DESC");
                                    $result_voucher->execute(array('hoje' => $hoje, 'hoje2' => $hoje, 'voucher' => $rowc['voucher']));
                                    $row_voucher = $result_voucher->fetch();
                                    if ($row_voucher['tipo']==1) {
                                        $desconto_voucher = number_format((float)$row_voucher['desconto'], 2, '.', '');
                                    } else {
                                        $percentagem = ($row_voucher['percentagem'] / 100) * $total;
                                        $desconto_voucher = number_format((float)$percentagem, 2, '.', '');
                                    }
                                    $total_voucher = $total-$desconto_voucher;
                                    if ($total_voucher<0) {
                                        $total_voucher = 0;
                                    }
                                    echo '<tr>
                                            <td>'.$textos['voucher'].'</td>
                                            <td>-'.$desconto_voucher.'€</td>
                                          </tr>';
                                } else {
                                    $total_voucher = $total;
                                }
                            ?>
							<tr>
                                <td><?php echo $textos['portes'];?></td>
                                <td>-</td>
                            </tr>
							 <?php
                                $resultc = $pdo->prepare("SELECT * FROM carrinho WHERE id_carrinho = :carrinho");
                                $resultc->execute(array('carrinho' => $_SESSION['id_carrinho']));
                                $rowc = $resultc->fetch();
                                if (!is_null($rowc['voucher'])) {
                                    echo '<tr class="total">
                                            <td>'.$textos['total'].'</td>
                                            <td class="total-amount">'.number_format((float)$total_voucher, 2, '.', '').'€</td>
                                          </tr>';
                                } else {
                                    echo '<tr class="total">
                                            <td>'.$textos['total'].'</td>
                                            <td class="total-amount">'.number_format((float)$total_voucher, 2, '.', '').'€</td>
                                          </tr>';
                                }
                            ?>
                        </table>
                    </div>
					 <?php
                    echo '<a onclick="continuar1();" class="btn d-block">'.$textos['continuar'].'</a>';
                ?>
                </div>
            </div>
        </div>
    </div>
<?php }?>
<script>
    document.getElementById("btn_voucher").addEventListener("click", function(event) {
		event.preventDefault()
    });

	function checkVoucher() {
        var voucher = $('#voucher').val();
		var total = <?php echo $total; ?>;
        $.ajax({
            type:'POST',
            url:'verificar-voucher.php?l=<?php echo $lingua;?>',
            data:{voucher: voucher, total: total},
            success:function(data) {
                carregarCheckout();
                at_carrinho();
                Swal.fire(data);
            },
        });
    }
</script>